ed395b2e409c17d44393bbdd0e25d479519fc4a1
[rip_dvd/.git] / rip_dvd
1 #!/bin/bash
2 #
3 # Author: Alan J. Pippin (apippin@pippins.net)
4 # Date: 05/17/2009
5 #
6   REV=1.0
7 #
8 # Description: This script wraps a number of linux utilities to
9 # create a recipe for ripping protected DVDs, circumventing 
10 # ARcoSS and CRC checksum error protection schemes used on many
11 # newer DVDs. Edit as appropriate for your needs. I use this to
12 # backup DVDs I own, and do not condone any other activity it
13 # may be used for.
14 #
15 # Known Issues/Limitations:
16 # - Mirror mode is always done in ISO mode
17 #
18 # Package Dependencies (apt-get install these for example):
19 # lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
20 #
21 # Specific Executable (program) Dependencies (must be found in $PATH):
22 # volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
23 #
24 # Optional Dependencies:
25 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
26 #
27
28 ##############################################################################
29 # Local Machine Settings:
30 # Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
31 # and the local conf file created by each local machine (rip_dvd.conf)
32 # Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
33 # This will allow you to override all the default values to meet your needs
34 # in a way that won't get clobbered when you pull updates from my GIT repo.
35 ##############################################################################
36 config="${0%/*}/rip_dvd.conf"
37 [ -e "${config}.dist" ] && . ${config}.dist
38 [ -e "${config}" ] && . ${config}
39
40 ##############################################################################################
41 # Command line processing
42 ##############################################################################################
43 typeset cmd="$0 $*"
44 typeset dvdname=""
45 typeset debug=""
46 typeset dest=""
47 typeset isofile=""
48 typeset vobfile=""
49 typeset dvdpath=""
50 typeset aspect=""
51 typeset SCALE=""
52 typeset CROP=""
53 typeset profile="xvidvhq"
54 typeset extension=""
55 typeset -i force_onepass_mode=0
56 typeset -i eject_disk=1
57 typeset -i keep_isofile=0
58 typeset -i keep_vobfile=0
59 typeset -i keep_dvdfolder=0
60 typeset -i keep_intermediate_files=0
61 typeset -i make_final_dest_vob=0
62 typeset -i make_final_dest_iso=0
63 typeset -i make_final_dest_folder=0
64 typeset -i make_final_dest_comp=0
65 typeset -i errors=0
66 typeset -i show_usage=0
67 typeset -i mirror_mode=0
68 typeset -i target_bitrate=2000
69 typeset -i target_size=0
70 typeset -i audio_2ch=0
71 typeset -i invalid_feature_title=0
72 typeset -i feature_title_override=0
73 typeset -i mplayer_dumpstream_incompatibility=0
74
75 while (($#)) && getopts 12mvifkxht:n:d:b:s:t:a:p:e:j: opt "$@"
76 do
77     case $opt in
78         (n)     dvdname=$OPTARG;;
79         (d)     dest=$OPTARG;;
80         (b)     target_bitrate=$OPTARG;;
81         (s)     target_size=$OPTARG;;
82         (2)     audio_2ch=1;;
83         (1)     force_onepass_mode=1;;
84         (v)     make_final_dest_vob=1;;
85         (i)     make_final_dest_iso=1;;
86         (f)     make_final_dest_folder=1;; 
87         (x)     make_final_dest_comp=1;;
88         (m)     mirror_mode=1;;
89         (k)     keep_intermediate_files=1;;
90         (t)     feature_title_override=$OPTARG;;
91         (a)     aspect=$OPTARG;;
92         (p)     profile=$OPTARG;;
93         (e)     extension=$OPTARG;;
94         (j)     eject_disk=$OPTARG;;
95         (w)     set -$opt;;
96         (h)     show_usage=1;;
97         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
98         (\?)    echo >&2 "$0: invalid option '$OPTARG'"; errors=errors+1;;
99     esac
100 done
101
102 shift $((OPTIND-1))
103
104 function usage() {
105     echo >&2 "Usage: ${0##*/} -d <destdir> [ <options> ]"
106     echo >&2 "Revision $REV"
107     echo >&2 "Options:"
108     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
109     echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
110     echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
111     echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
112     echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
113     echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
114     echo >&2 "                 5) If dvdname is a full path to an ISO file, it will be ripped as a DVD instead of $dev"
115     echo >&2 "   -p <profile>  Specify which encoding profile to use in -x mode as shown below:"
116     echo >&2 "                 - xvidvhq = AVI, very high quality encoding, Xvid codec, 2 pass encoding (default)"
117     echo >&2 "                 - xvidhq = AVI, high quality encoding, Xvid codec, 2 pass encoding"
118     echo >&2 "                 - xvid = AVI, fast encoding, Xvid codec, 2 pass encoding"
119     #echo >&2 "                 - mp4vhq = MP4, very high quality encoding, x264 codec, 2 pass encoding"
120     #echo >&2 "                 - mp4hq = MP4, high quality encoding, x264 codec, 2 pass encoding"
121     #echo >&2 "                 - mp4 = MP4, fast encoding, x264 codec, 2 pass encoding"
122     echo >&2 "                 - iphone = MP4, x264 codec, 2 pass encoding, forced 480:320 scaling"
123     echo >&2 "                 - ipod = MP4, x264 codec, 2 pass encoding, forced 320:240 scaling"
124     echo >&2 "   -e <ext>      Specify a suffix extension to apply to the end of the final image filename (like .xvid, .ipod, etc)"
125     echo >&2 "                 If you run multiple instances of this script ripping the same DVD, you need to specify this option."
126     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
127     echo >&2 "                 The default operation is non-mirror mode where only the main"
128     echo >&2 "                 feature title will be ripped."
129     echo >&2 "   -v            Make the final image a DVD VOB file"
130     echo >&2 "   -i            Make the final image a DVD ISO file"
131     echo >&2 "   -f            Make the final image a DVD folder"
132     echo >&2 "   -x            Make the final image a compressed file based on your profile selection"
133     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
134     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
135     echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
136     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
137     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
138     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
139     echo >&2 "   -j <n>        Eject the disk:"
140     echo >&2 "                 - 0 = do not eject the disk"
141     echo >&2 "                 - 1 = eject after the entire script is done (default)"
142     echo >&2 "                 - 2 = eject after the disk is no longer needed (prior to starting the encode process)"
143     echo >&2 "                 The last option will allow you to start ripping another disk while the encoding process is running on a previous"
144     echo >&2 "   -1            Force 1-pass encoding mode across all profiles"
145     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making a compressed file (default is 6 channel AC3)"
146     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
147     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
148     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
149     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
150     echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
151     echo >&2 ""
152     exit 2
153 }
154
155 if (($errors)) || (($show_usage))
156 then
157   usage
158 fi
159
160 # Sanity Check - Command Line Options 
161 if [ "$dest" == "" ]; then
162   echo "-E- You must specify a destination directory with '-d'" | tee -a $logfile
163   usage
164 fi
165
166 if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -ne 1 ]; then
167   echo "-E- You can't specify a target_size, or aspect in non compressed file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
168   usage
169 fi
170
171 if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
172   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-x'" | tee -a $logfile
173   usage
174 fi
175
176 if [ $make_final_dest_vob -eq 0 ] && [ $make_final_dest_iso -eq 0 ] && 
177    [ $make_final_dest_folder -eq 0 ] && [ $make_final_dest_comp -eq 0 ] && [ $mirror_mode -eq 0 ]; then
178   echo "-E- You must specify what type of final destination you want: '-m' or '-v' or '-i' or '-f' or '-x'" | tee -a $logfile
179   usage
180 fi
181
182 if [ $mirror_mode -eq 1 ]; then
183   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_iso -eq 1 ] || 
184      [ $make_final_dest_folder -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
185     echo "-E- You can't specify '-v' or '-i' or '-f' or '-x' when operating in mirror mode with '-m'" | tee -a $logfile
186     usage
187   fi
188 fi
189
190 # If the aspect ratio option was specified, set the scale variable appropriately for mencoder
191 if [ "$aspect" != "" ]; then
192   echo "$aspect" | grep -q "x"
193   if [ $? == 0 ]; then
194     echo "-E- You must specify the aspect option with a value whose format is W:H"
195     exit 1
196   fi
197   echo "$aspect" | grep -q ":"
198   if [ $? != 0 ]; then
199     SCALE=",scale -zoom -sws 9 -xy $aspect"
200   else
201     SCALE=",scale=$aspect"
202   fi
203 fi
204
205
206 # Sanity Check - Key executables
207 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
208 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
209 [[ ! -x `which ddrescue` ]] && echo "-E- missing dependency: ddrescue" && exit
210 [[ ! -x `which dvdbackup` ]] && echo "-E- missing dependency: dvdbackup" && exit
211 [[ ! -x `which mencoder` ]] && echo "-E- missing dependency: mencoder" && exit
212 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
213 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
214 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
215
216 ##############################################################################################
217
218 typeset -i ripdvd
219 if [ -z "$dvdname" ]; then
220   # make sure the DVD device is accessible
221   volname $dev > /dev/null 2>&1
222   if [ $? != 0 ]; then
223     echo "-E- Can't access the DVD device $dev"
224     exit 1
225   fi
226   # now capture the volume name from the device
227   dvdname=`volname $dev | awk '{ print $1 }'`
228   ripdvd=1
229 else 
230   # check to see if dvdname is a full path to a real directory
231   # if it is, set dvdname and dvdpath appropriately
232   if [ -d "$dvdname" ]; then
233     dvdpath="$dvdname"
234     dvdname=`basename "$dvdname"`
235     keep_dvdfolder=1
236     if [ -z "$dvdname" ]; then
237      echo "-E- Unable to extract dvdname from path: $dvdpath"
238      exit 1
239     fi
240     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
241       echo "-E- You must supply a full path to a valid DVD folder with this option"
242       exit 1
243     fi
244   fi
245
246   # Check to see if dvdname is a full path to a file
247   if [ -f "$dvdname" ]; then
248     valid_file=0
249
250     # check to see if dvdname is a full path to an MPG2 (VOB) file
251     # if it is, set dvdname and vobfile appropriately
252     file "$dvdname" | grep -q "MPEG"
253     if [ $? == 0 ]; then
254       # It is a valid MPEG2 file, now strip the extension off our dvdname
255       vobfile="$dvdname"
256       dvdname=`basename "$dvdname"`
257       dvdname=${dvdname%.[^.]*}
258       keep_vobfile=1
259       valid_file=1
260     fi
261
262     # check to see if dvdname is a full path to an ISO file
263     # if it is, set dvdname and isofile appropriately
264     file "$dvdname" | grep -q -e "ISO" -e "UDF"
265     if [ $? == 0 ]; then
266       # It is a valid ISO file, now strip the extension off our dvdname
267       isofile="$dvdname"
268       dvdname=`basename "$dvdname"`
269       dvdname=${dvdname%.[^.]*}
270       keep_isofile=1
271       valid_file=1
272     fi    
273
274     # If we didn't find a handler for the file above, complain
275     if [ $valid_file -eq 0 ]; then
276       echo "-E- Unsupported file type: $vobfile"
277       exit 1
278     fi
279   fi
280   ripdvd=0
281   # Since we aren't ripping a DVD disk, don't eject anything
282   eject_disk=0
283 fi
284
285 # remove bad characters from the dvdname
286 dvdname=${dvdname%.} # remove trailing '.' character
287
288 # add the suffix extension to the end of the dvdname
289 dvdname=$dvdname$extension
290
291 # make a "safe" dvdname (remove special characters)
292 safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
293
294 # Make sure we have a non-empty dvdname
295 if [ -z "$dvdname" ]; then
296   echo "-E- unable to determine dvdname"
297   exit 1
298 fi
299
300 # make sure our vobfile value is set
301 if [ -z "$vobfile" ]; then
302   vobfile="$dest/$dvdname.VOB"
303 fi
304
305 # set up some variables to hold various logfiles
306 logfile="$logdir/$dvdname.log"
307 passlogfile="$tmpdir/$safedvdname.log"
308 ddrescuelog=`tempfile`
309 dvdauthorlog=`tempfile`
310 encodelog=`tempfile`
311 dumplog=`tempfile`
312
313 # create the tmpdir if it doesn't already exist
314 if [ ! -d "$tmpdir" ]; then
315   mkdir -p "$tmpdir"
316   if [ $? != 0 ]; then
317     echo "-E- Unable to create the tmpdir: $tmpdir"
318     exit 1
319   fi
320 fi
321
322 # create the logdir if it doesn't already exist
323 if [ ! -d "$logdir" ]; then
324   mkdir -p "$logdir"
325   if [ $? != 0 ]; then
326     echo "-E- Unable to create the logdir: $logdir"
327     exit 1
328   fi
329 fi
330
331 ##############################################################################################
332 # cleanup functions
333 ##############################################################################################
334 cleanup() { 
335   if [ $keep_intermediate_files -eq 0 ]; then
336     [[ -e "$dvdauthorlog" ]] && rm -f "$dvdauthorlog"
337     [[ -e "$ddrescuelog" ]] && rm -f "$ddrescuelog"
338     [[ -e "$encodelog" ]] && rm -f "$encodelog"
339     [[ -e "$dumplog" ]] && rm -f "$dumplog"
340   else
341     [[ -e "$dvdauthorlog" ]] && echo "-> Keeping dvdauthor log: $dvdauthorlog" | tee -a "$logfile"
342     [[ -e "$ddrescuelog" ]] && echo "-> Keeping ddrescue log: $ddrescuelog" | tee -a "$logfile"
343     [[ -e "$encodelog" ]] && echo "-> Keeping encode log: $encodelog" | tee -a "$logfile"
344     [[ -e "$dumplog" ]] && echo "-> Keeping dump log: $dumplog" | tee -a "$logfile"
345   fi
346   echo ""
347 }
348
349 fatal_and_exit() {
350   if [[ -z "$1" ]]; then
351     msg="-E- control-c killed us"
352   else
353     msg=$1
354   fi
355   echo -e 2>&1 "$msg" | tee -a "$logfile"
356   if [[ -n "$mailto" ]]; then
357     echo -e "$msg" | mailx -s "dvd rip of $dvdname FAILED" "$mailto"
358   fi
359   keep_intermediate_files=1
360   exit 1
361 }
362
363 # Call our cleanup functions on INT and EXIT signals
364 trap fatal_and_exit INT
365 trap cleanup EXIT
366
367 ##############################################################################################
368 # processing functions
369 ##############################################################################################
370
371 # encode the vob file into a compressed file format
372 function encode_vob_file {
373
374   # Set a variable that we will use later to determine if we found a handler for $profile or not
375   typeset -i found_profile=0
376
377   # For a given profile, to override the 2 pass behavior to be single pass,
378   # simply set the PASSES variable below to "2" instead of "1 2" inside your profile handler. 
379   # It indicates which PASS numbers to loop over. PASSES="2" means just do pass 2 => single pass mode.
380   PASSES="1 2"
381
382   # Declare our default 2 pass variables
383   passlogfile_opt="-passlogfile $passlogfile"
384   pass_opt="pass=%PASS"
385
386   # Check the global force_onepass_mode. If it is set, change our variables appropriately
387   # to force 1-pass encoding across all profiles.
388   if [ $force_onepass_mode -eq 1 ]; then
389     PASSES="2"
390     passlogfile_opt=""
391     pass_opt=""    
392   fi
393
394   # XVID profile
395   if [ "$profile" == "xvid" ] || [ "$profile" == "xvidhq" ] || [ "$profile" == "xvidvhq" ]; then
396     found_profile=1
397     final_output_file="$dest/$dvdname.avi"
398     mencoder_general_opts="$lang_opts $passlogfile_opt"
399     mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
400     mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
401     mencoder_video_encoder_opts="-ovc xvid -xvidencopts $pass_opt"
402
403     # Very High Quality (16fps)
404     if [ "$profile" == "xvidvhq" ]; then
405       video_encoder_opts[0]="bitrate=$target_bitrate"
406       video_encoder_opts[1]="threads=$mencoder_threads"
407       video_encoder_opts[2]="chroma_opt"
408       video_encoder_opts[3]="vhq=4"
409       video_encoder_opts[4]="bvhq=1"
410       video_encoder_opts[5]="quant_type=mpeg"
411       video_encoder_opts[6]="autoaspect"
412     fi
413     # High Quality (20fps)
414     if [ "$profile" == "xvidhq" ]; then
415       video_encoder_opts[0]="bitrate=$target_bitrate"
416       video_encoder_opts[1]="threads=$mencoder_threads"
417       video_encoder_opts[2]="chroma_opt"
418       video_encoder_opts[3]="vhq=2"
419       video_encoder_opts[4]="bvhq=1"
420       video_encoder_opts[5]="quant_type=mpeg"
421       video_encoder_opts[6]="autoaspect"
422     fi
423     # Fast (28fps)
424     if [ "$profile" == "xvid" ]; then
425       video_encoder_opts[0]="bitrate=$target_bitrate"
426       video_encoder_opts[1]="threads=$mencoder_threads"
427       video_encoder_opts[2]="vhq=0"
428       video_encoder_opts[3]="turbo"
429       video_encoder_opts[4]="autoaspect"
430     fi
431
432     for OPTS in "${video_encoder_opts[@]}"; do 
433       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
434     done
435
436     if [ $audio_2ch -eq 0 ]; then
437       # These options produce good 6 channel audio for linux and windows
438       mencoder_audio_opts="-oac copy"
439       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
440       mencoder_audioch_opts[0]="-channels 6 -af channels=6"
441       mencoder_audioch_opts[1]="-af channels=6"
442       mencoder_audioch_opts[2]=""
443     else
444       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
445       mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
446       mencoder_audioch_opts[0]=""
447     fi
448  
449   fi
450
451   # MP4 encoding profiles
452   # These are currently in BETA. They don't work that great. A new recipe is needed, for the audio.
453   if [ "$profile" == "mp4" ] || [ "$profile" == "mp4hq" ] || [ "$profile" == "mp4vhq" ]; then
454     found_profile=1
455     final_output_file="$dest/$dvdname.mp4"
456     mencoder_general_opts="$lang_opts $passlogfile_opt"
457     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
458     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
459     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
460
461     # Very High Quality (6fps)
462     if [ "$profile" == "mp4vhq" ]; then
463       video_encoder_opts[0]="bitrate=$target_bitrate"
464       video_encoder_opts[1]="threads=$mencoder_threads"
465       video_encoder_opts[2]="subq=6"
466       video_encoder_opts[3]="frameref=5"
467       video_encoder_opts[4]="bframes=3"
468       video_encoder_opts[5]="8x8dct"
469       video_encoder_opts[6]="me=umh"
470       video_encoder_opts[7]="b_pyramid"
471       video_encoder_opts[8]="weight_b"
472       video_encoder_opts[9]="partitions=all" 
473     fi
474     # High Quality (13fps)
475     if [ "$profile" == "mp4hq" ]; then
476       video_encoder_opts[0]="bitrate=$target_bitrate"
477       video_encoder_opts[1]="threads=$mencoder_threads"
478       video_encoder_opts[2]="subq=5"
479       video_encoder_opts[3]="frameref=2"
480       video_encoder_opts[4]="bframes=3"
481       video_encoder_opts[5]="8x8dct"
482       video_encoder_opts[6]="b_pyramid"
483       video_encoder_opts[7]="weight_b"
484     fi
485     # Fast (17fps)
486     if [ "$profile" == "mp4" ]; then
487       video_encoder_opts[0]="bitrate=$target_bitrate"
488       video_encoder_opts[1]="threads=$mencoder_threads"
489       video_encoder_opts[2]="subq=4"
490       video_encoder_opts[3]="bframes=2"
491       video_encoder_opts[4]="b_pyramid"
492       video_encoder_opts[5]="weight_b"
493     fi
494
495     for OPTS in "${video_encoder_opts[@]}"; do
496       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
497     done
498
499     if [ $audio_2ch -eq 0 ]; then
500       # These options produce good 6 channel audio for linux and windows
501       #mencoder_audio_opts="-oac copy"
502       # There are 3 different ways to specify 6 channel encoding. We'll try the other ones in order if one of them fails.
503       #mencoder_audioch_opts[0]="-channels 6 -af channels=6"
504       #mencoder_audioch_opts[1]="-af channels=6"
505       #mencoder_audioch_opts[2]=""
506       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
507       mencoder_audioch_opts[0]="-channels 6 -srate 48000"
508     else
509       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
510       #mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
511       #mencoder_audioch_opts[0]=""
512       mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
513       mencoder_audioch_opts[0]="-channels 2 -srate 48000"
514     fi
515
516   fi
517
518   # iphone and ipod MP4 profiles
519   if [ "$profile" == "iphone" ] || [ "$profile" == "ipod" ]; then
520     found_profile=1
521     if [ "$profile" == "iphone" ]; then
522       # SCALE: 480x320
523       # scale width to 480, set height appropriately, but keep a multiple of 16
524       #SCALE=",scale=480:-10"
525       # scale the video down however far is necessary to fit in 480x320
526       SCALE=",dsize=480:320:0,scale=-8:-8"
527     else
528       # SCALE: 320x240
529       # scale width to 320, set height appropriately, but keep a multiple of 16
530       #SCALE=",scale=320:-10"
531       # scale the video down however far is necessary to fit in 320x240
532       SCALE=",dsize=320:240:0,scale=-8:-8"
533     fi
534     final_output_file="$dest/$dvdname.mp4"
535     mencoder_general_opts="$lang_opts $passlogfile_opt"
536     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
537     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
538     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
539     video_encoder_opts[0]="bitrate=$target_bitrate"
540     video_encoder_opts[1]="threads=$mencoder_threads"
541     video_encoder_opts[2]="vbv_maxrate=1500"
542     video_encoder_opts[3]="vbv_bufsize=2000"
543     video_encoder_opts[4]="nocabac"
544     video_encoder_opts[5]="me=umh"
545     video_encoder_opts[6]="subq=6"
546     video_encoder_opts[7]="frameref=6"
547     video_encoder_opts[8]="trellis=1"
548     video_encoder_opts[9]="level_idc=30"
549     video_encoder_opts[10]="global_header"
550     video_encoder_opts[11]="bframes=0"
551     video_encoder_opts[12]="partitions=all"
552     for OPTS in "${video_encoder_opts[@]}"; do 
553       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
554     done
555
556     mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
557     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
558   fi
559
560   if [ $found_profile -eq 0 ]; then
561     fatal_and_exit "-E- Unable to find a profile handler for profile: $profile"
562   fi
563
564   # Do not edit this line. $mencoder_video_encoder_opts must be last
565   mencoder_opts="$mencoder_general_opts $mencoder_output_opts $mencoder_audio_opts $mencoder_video_filter_opts $mencoder_video_encoder_opts"
566   mencoder_retval=0
567
568   for PASS in $PASSES
569   do 
570     # Set some options based on which pass we are in
571     mencoder_opts_for_pass=$(echo "$mencoder_opts" | sed "s,%PASS,$PASS,g")
572     [ $PASS -eq 1 ] && mencoder_opts_for_pass="$mencoder_opts_for_pass:turbo"
573     [ $PASS -eq 1 ] && output_file="/dev/null"
574     [ $PASS -eq 2 ] && output_file="$final_output_file"
575   
576     # It's possible that the audio channel encoding may not work. Cycle through all our different audioch_opts until we find one that works.
577     for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
578     do
579       echo -e "   Encoding pass $PASS"
580       echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
581       mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
582       mencoder_retval=$? 
583       grep -q "\[channels\] Invalid" $encodelog
584       if [ $? != 0 ]; then          
585         break;
586       else
587         echo -e "\n-W- Audio channel encoding error. Falling back to next audio channel encoding scheme." >> "$logfile"
588       fi
589     done
590       
591     if [ $mencoder_retval != 0 ]; then
592       fatal_and_exit "-E- Unhandled mencoder error"
593     fi
594
595     # Concatenate the encode log to our main log file, greping out unwanted lines
596     cat $encodelog | grep -v "^Pos:" | grep -v "duplicate" >> "$logfile"
597
598   done
599 }
600
601 function make_dvd_iso_image {
602
603   isofile="$1"
604
605   # check to see if we have a dvdpath to rip from instead of $dev
606   if [ -z "$dvdpath" ]; then
607     # load the CSS codes in the DVD drive 
608     lsdvd $dev >> "$logfile"
609     if [ $? != 0 ]; then
610       fatal_and_exit "-E- lsdvd $dev failed" 
611     fi
612
613     # read the DVD, ignoring/skipping CRC errors
614     ddrescue -n -b 2048 $dev "$isofile" "$ddrescuelog"
615     if [ $? != 0 ]; then
616       fatal_and_exit "-E- ddrescue -n -b 2048 $dev \"$isofile\" failed"
617     fi
618     cat "$ddrescuelog" >> "$logfile"
619   else
620     # rip from a path instead
621     make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
622   fi
623 }
624
625 function make_dvd_iso_image_from_folder {
626   
627   src="$1"
628   dst="$2"
629   handle_error=$3
630   
631   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
632
633   # make an iso image out of our directory
634   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
635   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
636
637   # set the audio languages from the iso if it exists and is non-zero in size
638   if [ -s "$dst" ]; then
639     get_feature_title "$dst"
640     get_audio_id_from_iso "$dst"
641   fi
642
643   # make sure we were able to create the iso image from the folder given to us
644   if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
645     echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
646     echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
647     # remove the bad iso file
648     [[ -e "$dst" ]] && rm -f "$dst"
649     # get the feature title from the DVD folder
650     get_feature_title "$dvdpath"
651     # create our main VOB file from the ISO
652     create_main_vob_with_mplayer "$dvdpath" 
653     # get our audio id from the VOB file
654     get_audio_id_from_vob "$vobfile"
655   fi
656 }
657
658 function make_dvdbackup_folder_image {
659   # extract the feature title from the DVD image
660   echo "-> Extracting feature title using dvdbackup" | tee -a "$logfile"
661   [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
662   dvdbackup -F -i "$isofile" -o "$tmpdir" >> "$logfile"
663   if [ $? != 0 ]; then
664     fatal_and_exit '-E- dvdbackup -F -i "$isofile" -o "$tmpdir" failed'
665   fi
666 }
667
668 function make_dvdauthor_folder_image {
669   # create a new DVD video of the feature title
670   echo "-> Creating DVD video $dest/$dvdname" | tee -a "$logfile"
671   [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
672   dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
673   cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
674
675   # There is a chance that dvdauthor won't like some of the VOBs.
676   # We can't tell ahead of time which ones it will choke on. 
677   # So, we need to run it over and over again until it can process
678   # all the VOBs. If it can't handle one of them, run it through
679   # mencoder to fix it and try again. These errors are typically
680   # present due to the copy protection that ddrescue removed.
681   grep -q "SCR moves" $dvdauthorlog
682   while [ $? == 0 ]; do
683     # fix bad vobs that get the "SCR moves backwards" error:
684     #  STAT: Processing VTS_01_0.VOB...
685     #  ERR:  SCR moves backwards, remultiplex input.
686     badvob=`grep -v "^WARN:" $dvdauthorlog | grep -B 1 "SCR moves" | grep "Processing" | awk '{ print $3 }' | sed -e 's/\.\.\.//'`
687     if [[ ! -f "$badvob" ]]; then
688       fatal_and_exit "-E- Found a bad VOB, but could not extract it's name properly: $badvob"
689     fi
690     echo "-> Fixing SCR errors in DVD video file $badvob" | tee -a "$logfile"
691     cat $badvob | mencoder $lang_opts -quiet -of mpeg -mpegopts format=dvd -oac copy -ovc copy - -o $badvob.fixed >> "$logfile" 2>&1
692     mv -f $badvob.fixed $badvob
693     echo "-> Creating DVD video $dest/$dvdname"
694     dvdauthor -o "$dest/$dvdname" -x dvd.xml > $dvdauthorlog 2>&1
695     cat $dvdauthorlog | grep -v "VOBU" >> "$logfile"
696     grep -q "SCR moves" $dvdauthorlog
697   done
698 }
699
700 function get_feature_title {
701   source="$1"
702   # if a feature title was given on the command line, use it
703   if [ $feature_title_override -ne 0 ]; then
704     feature_title=$feature_title_override
705     return 0
706   fi
707   # otherwise, use lsdvd to figure it out
708   if [ $ripdvd -eq 1 ]; then
709     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
710   else 
711     feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
712   fi
713 }
714
715 function create_main_vob_with_cat {
716   # cd to the feature title DVD folder
717   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
718   if [ $? != 0 ]; then
719     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
720   fi
721
722   # concatenate all the VOBs together into 1 giant VOB
723   vobs=`/bin/ls -1 VTS*.VOB | grep -v "0.VOB" | tr '\n' ' '`
724   cat $vobs > "$tmpdir/$dvdname.VOB"
725
726   # cd back to the dir we started from
727   popd > /dev/null 2>&1
728 }
729
730 function create_main_vob_with_mplayer {
731
732   # argument processing  
733   source="$1"
734   remove_dumplog=$2
735
736   # make sure we have a valid feature title
737   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
738     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
739   fi
740
741   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
742   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
743     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
744     msg="$msg We also detected another condition that requires us to use dumpstream. "
745     msg="$msg\n    Unable to rip this DVD in the mode you requested."
746     fatal_and_exit "$msg"
747   fi
748
749   # use mplayer to create the main VOB file
750   echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
751   echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
752   mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
753   if [ $? != 0 ]; then
754     cat $dumplog | grep -v "^A:" >> "$logfile"
755     fatal_and_exit "-E- Mplayer Failed"
756   fi
757   cat $dumplog | grep -v "^A:" >> "$logfile"
758   [[ -e "$dumplog" ]] && [[ $remove_dumplog -eq 1 ]] && rm -f $dumplog
759 }
760
761 function get_audio_id_from_iso {
762   # Adjust our audio ID to find the english audio stream
763   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
764   iso="$1"
765   aidcheck=`tempfile`
766   aid=128
767   mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
768   grep -q "aid: $aid" $aidcheck
769   while [ $? == 1 ] && [ $aid -lt 159 ]; do
770     (( aid = aid + 1 ))
771     grep -q "aid: $aid" $aidcheck
772   done
773   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
774   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
775   # mencoder default DVD audio track language selection (english)
776   lang_opts="-aid $aid -alang en"
777 }
778
779 function get_crop_from_iso { 
780   FRAMES=10000
781   echo "-> Detecting black frame border crop value from ISO file"
782   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
783   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
784   [[ -e "md5sums" ]] && rm -f "md5sums"
785   CROP=`cat $dumplog | grep CROP | tail -1`
786   echo "   Found crop value of $CROP" >> "$logfile"
787   CROP=${CROP#* crop=}
788   CROP=${CROP%%\).*}
789   typeset -i CROPCHECK
790   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
791   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
792   if [ -z "$CROP" ]; then
793     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
794     return
795   fi
796   if [ $CROPCHECK -lt 0 ]; then 
797     CROP=""
798   else 
799     CROP=",crop=$CROP"
800   fi
801   echo "   Setting mencoder crop filter to: $CROP"
802 }
803
804 function get_crop_from_vob { 
805   FRAMES=10000
806   echo "-> Detecting black frame border crop value from VOB file"
807   echo "   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark \"$vobfile\" > $dumplog 2>&1" >> "$logfile"
808   mplayer -vf cropdetect -frames $FRAMES -nosound -vo md5sum -benchmark "$vobfile" > $dumplog 2>&1
809   [[ -e "md5sums" ]] && rm -f "md5sums"
810   CROP=`cat $dumplog | grep CROP | tail -1`
811   echo "   Found crop value of $CROP" >> "$logfile"
812   CROP=${CROP#* crop=}
813   CROP=${CROP%%\).*}
814   typeset -i CROPCHECK
815   CROPCHECK=`echo "$CROP" | awk -F ':' '{ print $1 }'`
816   echo "   Final crop value of $CROP with cropcheck value of $CROPCHECK" >> "$logfile"
817   if [ -z "$CROP" ]; then
818     echo "-W- Unable to extract CROP value from iso: $isofile" | tee -a "$logfile"
819     return
820   fi
821   if [ $CROPCHECK -lt 0 ]; then 
822     CROP=""
823   else 
824     CROP=",crop=$CROP"
825   fi
826   echo "   Setting mencoder crop filter to: $CROP"
827 }
828
829 function get_audio_id_from_vob {
830   # Adjust our audio ID to find the english audio stream
831   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
832   vob="$1"
833   aidcheck=`tempfile`
834   aid=128
835   mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
836   grep -q "Found audio stream: $aid" $aidcheck
837   while [ $? == 1 ] && [ $aid -lt 159 ]; do
838     (( aid = aid + 1 ))
839     grep -q "Found audio stream: $aid" $aidcheck
840   done
841   [[ -e "$aidcheck" ]] && rm -f "$aidcheck"
842   echo "-> Setting the audio stream ID to $aid" | tee -a "$logfile"
843   # mencoder default DVD audio track language selection (english)
844   lang_opts="-aid $aid -alang en"
845 }
846
847 function check_vob_for_corrupted_start {
848   # check to see if the beginning of the DVD has a form of copy protection
849   # where they have deliberately broken the first X number of frames of the DVD.
850   # If we don't skip these, our resulting VOB file will not play.
851   badvobcheck=`tempfile`
852   endpos=360
853   skip=0
854   mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
855   if [ $? != 0 ]; then
856     fatal_and_exit "-E- Mencoder Failed"
857   fi
858   grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
859   while [ $? == 0 ] && [ $skip -lt $endpos ]; do
860     (( skip = skip + 5 ))
861     echo "-> Bad VOB copy protection detected. Trying new skip value of $skip" | tee -a "$logfile"
862     mencoder -ss $skip -endpos $endpos $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy "$tmpdir/$dvdname.VOB" -o /dev/null > $badvobcheck 2>&1
863     if [ $? != 0 ]; then
864       fatal_and_exit "-E- Mencoder Failed"
865     fi
866     grep "Writing header" -A `wc $badvobcheck | awk '{ print $1 }'` $badvobcheck | grep -q "Too many video packets in the buffer"
867   done
868   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
869
870   # cat the giant VOB into mencoder to create a playable VOB file
871   cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
872   if [ $? != 0 ]; then
873     fatal_and_exit "-E- Mencoder Failed"
874   fi
875 }
876
877 function check_vob_for_completeness {
878   # check to make sure we got out a complete VOB.
879   # there is another kind of copy protection where the VOB's may
880   # have "MPG EOF" frames in the middle of the stream. 
881   # this causes mencoder to not process the entire VOB, and exit without any errors.
882   # detect this by seeing how much smaller the dst vob is from the src vob.
883   MAX_FILESIZE_DELTA_PERCENT=70
884   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
885   DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
886   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
887   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
888     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
889     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
890     create_main_vob_with_mplayer "$isofile"
891     [[ -e "$dumplog" ]] && rm -f $dumplog
892     DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
893     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
894     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
895       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
896     fi
897   fi
898 }
899
900 function check_vob_for_too_many_video_packets {
901   # If our earlier algorithm to work around this failed, throw an error.
902   # check to see if this DVD has a protection scheme we don't know how to work around
903   # when I tried to burn the CARS DVD for example, you can't play the resulting VOB file.
904   # for some reason, the video is black, while the audio rolls, then the video finally comes
905   # in, but it is WAY off the audio. This appears to be due to some bad frames at the beginning of 
906   # the 1st VOB. Until I figure out how to work around this, detect it, and error out.
907   # instead of pulling the image from the disk again, you can pull it directly from the iso: -dvd-device $iso_path
908   grep -q "Too many video packets in the buffer:" "$logfile"
909   if [ $? == 0 ]; then
910     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
911     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
912     create_main_vob_with_mplayer "$isofile"
913     grep -q "Too many video packets in the buffer:" $dumplog
914     if [ $? == 0 ]; then
915       [[ -e "$dumplog" ]] && rm -f $dumplog
916       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
917     fi
918     [[ -e "$dumplog" ]] && rm -f $dumplog
919   fi
920 }
921
922 function check_vob_for_a52_crc_errors {
923   # Let's see if we can playback our newly created VOB file without any errors.
924   # if there are issues, let's detect them now, and try to recreate the VOB
925   # there are some forms of copy protection that have missed above, that evidence
926   # themselves when we try to playback the VOB file. This was added to deal with
927   # the "a52: CRC check failed" copy protection scheme.
928   MAX_ERRORS=10
929   ENDPOS=120
930   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
931   mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
932   cat $dumplog | grep -v "^A:" >> "$logfile"
933   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
934   if [ $errors -gt $MAX_ERRORS ]; then
935     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
936     create_main_vob_with_mplayer "$isofile"
937     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
938     mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
939     if [ $? != 0 ]; then
940       cat $dumplog | grep -v "^A:" >> "$logfile"
941       fatal_and_exit "-E- Mplayer Failed"
942     fi
943     cat $dumplog | grep -v "^A:" >> "$logfile"
944     errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
945     if [ $errors -gt $MAX_ERRORS ]; then
946       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n   I recommend using another ripping mode like '-m' or '-i'"
947     fi
948   fi
949   [[ -e "$dumplog" ]] && rm -f $dumplog
950 }
951
952 function calculate_bitrate_from_target_size {
953   # determine what our bitrate needs to be if a target size was specified instead
954   if [ $target_size -ne 0 ]; then
955     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
956     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
957     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
958   fi
959 }
960
961 function create_dvdauthor_dvd_xml_file {
962   # make a dvdauthor xml menu file to create a valid DVD video from 
963   # this script does a good job, but we'll still need to clean it up a bit after it runs
964   echo "-> Creating dvdauthor XML menu file" | tee -a "$logfile"
965   makexml -overwrite -dvd *.VOB -out dvd >> "$logfile" 2>&1
966   if [ $? != 0 ]; then
967     fatal_and_exit '-E- makexml -dvd *.VOB -out dvd failed'
968   fi
969
970   # replace the first line of the xml file to remove the bad dest path
971   awk -v line=1 -v new_content="<dvdauthor>" '{
972     if (NR == line) {
973       print new_content;
974     } else {
975       print $0;
976     }
977   }' dvd.xml > dvd.xml.new
978   mv -f dvd.xml.new dvd.xml
979   if [ $? != 0 ]; then
980     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
981   fi
982
983   # remove the "<video " property line from the xml file
984   cat dvd.xml | grep -v "<video" > dvd.xml.new
985   mv -f dvd.xml.new dvd.xml
986   if [ $? != 0 ]; then
987     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
988   fi
989   
990   # remove the extra <pgc>..</pgc> pairs
991   cat dvd.xml | awk 'BEGIN {x=1}
992   {
993     if ($0~"</pgc>") {x=0}
994     if (x==1) {print $0}
995     if ($0~"<pgc>") {x=1}
996   }' > dvd.xml.new
997   echo -e "</pgc>\n</titles>\n</titleset>\n</dvdauthor>" >> dvd.xml.new
998   mv -f dvd.xml.new dvd.xml
999   if [ $? != 0 ]; then
1000     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1001   fi
1002
1003   # remove the VTS_*_0.VOB file as this is just the main menu video clip
1004   cat dvd.xml | grep -v "VTS_.*_0.VOB" > dvd.xml.new
1005   mv -f dvd.xml.new dvd.xml
1006   if [ $? != 0 ]; then
1007     fatal_and_exit '-E- mv dvd.xml.new dvd.xml failed'
1008   fi
1009 }
1010
1011 function check_for_mplayer_dumpstream_incompatibility {
1012
1013   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
1014
1015   if [ ! -e "$vobfile" ]; then
1016     # mplayer dumpstream does not work on DVDs that obscure the feature title.
1017     # A DVD that has 99 titles, where the longest title isn't the main feature
1018     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
1019     # out what the feature title is. This script will run through that flow if we
1020     # set use_mplayer_dumpstream to 0. Check for this here.
1021     if [ $ripdvd -eq 1 ]; then
1022       lsdvd $dev | grep -q "Title: 99"
1023     else
1024       lsdvd "$isofile" | grep -q "Title: 99"
1025     fi
1026     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
1027     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
1028       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
1029         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
1030         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1031         echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
1032         invalid_feature_title=1
1033       else 
1034         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
1035         echo "-W- We still may not be able to autodetect the right feature title" | tee -a "$logfile"
1036         echo "    You may need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
1037         use_mplayer_dumpstream=0
1038         invalid_feature_title=1
1039       fi
1040       return
1041     fi
1042   fi
1043
1044   # There is another form of protection that causes the mplayer dumpstream to fail. 
1045   # This can be detected by telling mplayer to parse the VOB file by copying its audio
1046   # video streams to a dummy output file (/dev/null). Do that here to check for that 
1047   # problem before continuing.
1048   if [ -e "$vobfile" ]; then
1049     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
1050     mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
1051     grep -q "Too many audio packets in the buffer" $dumplog
1052     if [ $? == 0 ]; then
1053       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
1054       use_mplayer_dumpstream=0
1055       mplayer_dumpstream_incompatibility=1
1056     fi
1057     [[ -e "$dumplog" ]] && rm -f $dumplog
1058   fi
1059 }
1060
1061 function fill_mythvideo_metadata {
1062
1063   # This function must be passed the filename as an argument
1064   # The filename must be a full path to the file
1065   filename="$1"
1066
1067   # Make sure the fill mythvideo metadata option has been set to 1
1068   if [ $fill_mythvideo_metadata -eq 0 ]; then
1069     echo "-> fill_mythvideo_metadata=0 therefore not updating mythvideo metadata for this rip" | tee -a "$logfile"
1070     return 0
1071   fi
1072
1073   # If the fill mythvideo metadata script is present, run it
1074   # fill_mythvideo_metadata.plThis will download the metadata for the DVD we ripped.
1075   if [[ -x `which fill_mythvideo_metadata.pl` ]]; then
1076     echo "-> Running fill_mythvideo_metadata.pl to lookup/add/update the metadata for this DVD: $filename" | tee -a "$logfile"
1077     fill_mythvideo_metadata.pl -N 0 -F "$filename" >> "$logfile" 2>&1
1078   else
1079     echo "-W- Unable to find the fill_mythvideo_metadata.pl script in your PATH. Unable to autofill the mythvideo DB for this rip." | tee -a "$logfile"
1080     echo "    Set the fill_mythvideo_metadata variable to 0 in the script to avoid running this step." | tee -a "$logfile"
1081   fi
1082 }
1083
1084 # remove the intermediate VOB file
1085 function remove_intermediate_vob_file {
1086   if [ $keep_intermediate_files -eq 0 ]; then
1087     [[ -e "$tmpdir/$dvdname.VOB" ]] && rm -f "$tmpdir/$dvdname.VOB"
1088   else
1089     echo "-> Keeping intermediate concatenated VOB file: $tmpdir/$dvdname.VOB" | tee -a "$logfile"
1090   fi
1091 }
1092
1093 # remove the original DVD image 
1094 function remove_intermediate_iso_file {
1095   [[ $keep_isofile -eq 1 ]] && return 1
1096   if [ $keep_intermediate_files -eq 0 ]; then
1097     [[ -e "$isofile" ]] && rm "$isofile"
1098   else
1099     echo "-> Keeping ddrescue intermediate iso file: $isofile" | tee -a "$logfile"
1100   fi
1101 }
1102
1103 # remove the intermediate dvdbackup folder
1104 function remove_intermediate_dvdbackup_folder {
1105   if [ $keep_intermediate_files -eq 0 ]; then
1106     [[ -d "$tmpdir/$dvdname" ]] && rm -rf "$tmpdir/$dvdname"
1107   else
1108     echo "-> Keeping intermediate dvdbackup folder: $tmpdir/$dvdname" | tee -a "$logfile"
1109   fi
1110 }
1111
1112 ##############################################################################################
1113 # MAIN
1114 ##############################################################################################
1115
1116 # Make a note of when this DVD rip started
1117 date=`date`
1118 echo -e "\n$date DVD rip started" >> "$logfile"
1119 echo "$cmd" >> "$logfile"
1120
1121 # Rip the DVD - Mirror Mode
1122 if [ $mirror_mode -eq 1 ]; then
1123   echo "-> Ripping DVD $dvdname to $dest"
1124
1125   # use ddrescue to make an ISO image of the disk
1126   make_dvd_iso_image "$dest/$dvdname.iso"
1127
1128   # add this video data to the mythtv DB
1129   fill_mythvideo_metadata "$dest/$dvdname.iso" 
1130
1131   # eject the disk upon completion
1132   if [ $eject_disk -ne 0 ]; then
1133     eject -T $dev
1134   fi
1135
1136   date=`date`
1137   echo "$date DVD rip completed" | tee -a "$logfile"
1138
1139   if [[ -n "$mailto" ]]; then
1140     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1141   fi
1142
1143 fi
1144
1145 # Rip the DVD - Main Title Feature Only
1146 if [ $mirror_mode -eq 0 ]; then
1147
1148   # Rip image from DVD
1149   if [ $ripdvd -eq 1 ]; then
1150     echo "-> Ripping DVD $dvdname to $dest" | tee -a "$logfile"
1151     # use ddrescue to make an ISO image of the disk
1152     make_dvd_iso_image "$tmpdir/$dvdname.iso"
1153   fi
1154
1155   # Rip image from DVD path
1156   if [ -n "$dvdpath" ]; then
1157     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
1158     make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
1159   fi
1160
1161   # make sure our isofile value is set
1162   if [ -z "$isofile" ]; then
1163     isofile="$tmpdir/$dvdname.iso"
1164   fi
1165      
1166   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_comp -eq 1 ]; then
1167
1168     if [ ! -e "$vobfile" ]; then
1169       echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
1170       
1171       # get the feature title from the ISO
1172       get_feature_title "$isofile"
1173  
1174       # get the crop value from the ISO
1175       get_crop_from_iso
1176
1177       # check for mplayer dumpstream incompatibilities
1178       # if they exist, this method will set this mode to 0.
1179       check_for_mplayer_dumpstream_incompatibility
1180
1181       if [ $use_mplayer_dumpstream -eq 1 ]; then 
1182
1183         # get our audio id from the ISO file
1184         get_audio_id_from_iso "$isofile"
1185
1186         # create our main VOB file from the ISO
1187         create_main_vob_with_mplayer "$isofile"
1188      
1189         # remove the intermediate VOB file
1190         remove_intermediate_vob_file
1191
1192         # it's possible that our VOB is still corrupted in some manner
1193         # check to make sure it is still a good VOB before continuing.
1194         check_for_mplayer_dumpstream_incompatibility
1195
1196       fi
1197  
1198       if [ $use_mplayer_dumpstream -eq 0 ]; then 
1199
1200         # use dvdbackup to make a DVD folder of the feature title
1201         make_dvdbackup_folder_image
1202   
1203         # create our main VOB file
1204         create_main_vob_with_cat
1205
1206         # get our audio id from the VOB file
1207         get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
1208   
1209         # check for corrupted VOB start
1210         check_vob_for_corrupted_start
1211  
1212         # check to make sure our VOB is complete
1213         check_vob_for_completeness
1214
1215         # check to make sure our VOB doesn't have too many video packets
1216         check_vob_for_too_many_video_packets
1217
1218         # check to make sure our VOB doesn't have a52 crc errors
1219         check_vob_for_a52_crc_errors
1220
1221         # remove the intermediate VOB file
1222         remove_intermediate_vob_file
1223
1224       fi
1225
1226       # remove the intermediate ISO file
1227       remove_intermediate_iso_file
1228
1229     else
1230       echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
1231       # get our audio id from the VOB file
1232       get_audio_id_from_vob "$vobfile"
1233       # get the crop value from the VOB
1234       get_crop_from_vob
1235     fi
1236
1237     # eject the DVD disk since we are finished with it
1238     [ $eject_disk -eq 2 ] && eject -T $dev
1239
1240     # encode the VOB file to a compressed file format
1241     if [ $make_final_dest_comp -eq 1 ]; then
1242       echo "-> Encoding the DVD video to a compressed file" | tee -a "$logfile"
1243
1244       # determine what our bitrate needs to be if a target size was specified instead
1245       calculate_bitrate_from_target_size        
1246      
1247       # encode the vob file into a compressed file format
1248       encode_vob_file
1249
1250       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
1251         [[ -e "$vobfile" ]] && [[ $keep_vobfile -eq 0 ]] && rm -f "$vobfile";
1252         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
1253       else
1254         echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
1255         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
1256       fi
1257     fi
1258
1259   # add this video data to the mythtv DB
1260   [ $make_final_dest_comp -eq 1 ] && fill_mythvideo_metadata "$final_output_file" 
1261   [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile" 
1262     
1263   else
1264
1265   # use dvdbackup to make a DVD folder of the feature title
1266   make_dvdbackup_folder_image
1267
1268   # cd to the feature title DVD folder
1269   pushd "$tmpdir/$dvdname/VIDEO_TS" > /dev/null 2>&1
1270   if [ $? != 0 ]; then
1271     fatal_and_exit "-E- Unable to cd to $tmpdir/$dvdname/VIDEO_TS"
1272   fi
1273   
1274   # create the dvd.xml file for dvdauthor
1275   create_dvdauthor_dvd_xml_file  
1276
1277   # make the final DVD folder image
1278   make_dvdauthor_folder_image
1279
1280   # add this video data to the mythtv DB
1281   fill_mythvideo_metadata "$dest/$dvdname/VIDEO_TS" 
1282  
1283   # cd back to the dir we started from
1284   popd > /dev/null 2>&1
1285
1286   if [ $make_final_dest_iso -eq 1 ]; then
1287
1288     # make an iso image out of our directory
1289     make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
1290    
1291     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
1292     if [ -s "$dest/$dvdname.iso" ]; then
1293       if [ $make_final_dest_folder -eq 0 ]; then
1294         echo "-> Removing DVD folder since ISO was created: $dest/$dvdname" | tee -a "$logfile"
1295         # remove the folder of the DVD image now that we have a .iso version of it
1296         [[ -d "$dest/$dvdname" ]] && rm -rf "$dest/$dvdname"
1297       fi
1298     else
1299       # we created an empty iso file, remove it
1300       echo "-> Removing empty ISO image: $dest/$dvdname.iso" | tee -a "$logfile"
1301       echo "-> Keeping the DVD folder since the ISO image couldn't be created properly: $dest/$dvdname"
1302       [[ -e "$dest/$dvdname.iso" ]] && rm "$dest/$dvdname.iso"
1303     fi
1304  
1305     # add this video data to the mythtv DB
1306     fill_mythvideo_metadata "$dest/$dvdname.iso" 
1307
1308   fi
1309
1310   fi
1311
1312   # remove the ddrescue DVD ISO image
1313   remove_intermediate_iso_file
1314
1315   # remove the tmp dvdbackup folder of the DVD image
1316   remove_intermediate_dvdbackup_folder
1317
1318   # eject the DVD disk upon completion
1319   [ $eject_disk -eq 1 ] && eject -T $dev
1320
1321   date=`date`
1322   echo "$date DVD rip completed" | tee -a "$logfile"
1323
1324   if [[ -n "$mailto" ]]; then
1325     cat "$logfile" | mailx -s "dvd rip of $dvdname DONE" "$mailto"
1326   fi
1327
1328 fi
1329
1330 ##############################################################################################